//+------------------------------------------------------------------+
//|                                       WilliamsTradeV1.2.2.mq4    |
//|                                        Copyright  2010, Brooky. |
//|                                                                  |
//| Indicator  based on CycleSurfer Trading System Concept           |
//|http://www.forex-tsd.com/suggestions-trading-systems              |
//                    25090-my-new-day-trading-system-rate-test.html |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Brooky."
#property link      "http://www.NoLinkYet.com"
#property indicator_separate_window
#property indicator_buffers 5

#property indicator_color1 C'48,48,48'
#property indicator_color2 Red
#property indicator_color3 DodgerBlue
#property indicator_color4 Red
#property indicator_color5 LightGreen


#property indicator_width1 6
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2


#property indicator_minimum -110
#property indicator_maximum 10

#property indicator_level1 -20
#property indicator_level2 -40
#property indicator_level3 -50
#property indicator_level4 -60
#property indicator_level5 -80

extern int       wperiod=2000;//williams percent
extern int       short_level=-60;//williams level to go short from
extern int       long_level=-40;//williams level to go long from
extern int       ma_period=1;//williams averaging curve
extern int       valid_bars_back=5;//Bars to look back as needed to be below or above trigger point
extern int       valid_bars_back_diff=1;//Amount that valid bars back should be above or below trigger point.
extern bool      show_trigger_lines = true;
extern double    Bars_Back = 3000;//Show indicator x many bars back to cut processing time
extern bool      alert_on = true;
double backfill[];
double ma[];
double maOnArray[];
double array[];
double arrow1[];
double arrow2[];
static datetime lastbar;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0,backfill);
  
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ma);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,maOnArray);


   
   //--------DRAW TWO ARROWS---+
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,234);//short arrow
   SetIndexBuffer(3,arrow1);
   SetIndexEmptyValue(3,0.0);
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,233);
   SetIndexBuffer(4,arrow2);
   SetIndexEmptyValue(4,0.0);
   

   
   //--name for DataWindow and indicator subwindow label---+
   IndicatorShortName("Williams_Trade_V1.2.2");
   SetIndexLabel(0,"Williams_Trade_V1.2.2");
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  //--------Tidies up after itself---+
      ObjectsDeleteAll(0,OBJ_ARROW);             
      ObjectDelete("WThighline");
      ObjectDelete("WTlowline");
      ObjectDelete("WTnowline");

 return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+


int start()
  {
   int    counted_bars=IndicatorCounted();
   //--------Get the arrays ready for data and backward read---+
   ArrayResize(array, Bars_Back);   
   ArraySetAsSeries(array, true);
   //---Puts a color behind everything.
   for( int i = Bars_Back-1; i >= 0; i--)
   { 
   backfill[i]=-100;
   }
   
   
   for( i = Bars_Back-1; i >= 0; i--){ 
          
      array[i] = iWPR(NULL,0,wperiod,i);
   }

   for( i = Bars_Back-1-wperiod; i >= 0; i--)  
   {    
    ma[i]       =  iWPR(NULL,0,wperiod,i);
    maOnArray[i] = iMAOnArray(array, 0,ma_period, 0, 0, i);
   }
   
//--------Check Bar Open--+
datetime lastbar;
int alert_now=0;
   datetime curbar = iTime(NULL,0,i);
   
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      alert_now=1;
   }else alert_now=0;
//--------Check for signals---+

for( i = Bars_Back-1-wperiod; i >= 0; i--)
{
//short
      if(maOnArray[i]<maOnArray[i+1] 
         && maOnArray[i]<short_level 
            && maOnArray[i+1]>=short_level 
               && maOnArray[i+valid_bars_back]> short_level+valid_bars_back_diff)
                   
      {
       arrow1[i]=ma[i];//arrow 
         
       string name2 = "Dn"+i;
       ObjectCreate(name2,OBJ_ARROW, 0, Time[i], High[i]+30*Point); //draw a dn arrow
       ObjectSet(name2, OBJPROP_STYLE, STYLE_SOLID);
       ObjectSet(name2, OBJPROP_ARROWCODE, SYMBOL_ARROWDOWN);
       ObjectSet(name2, OBJPROP_COLOR,Red);

      }
         else {arrow1[i]=0.00;}
         
      //==short alert--+
            if(maOnArray[0]<maOnArray[1] 
               && maOnArray[0]<short_level 
                  && maOnArray[1]>=short_level 
                     && maOnArray[0+valid_bars_back]> short_level+valid_bars_back_diff)
               {
               if(alert_on== true && NewBar()==true )Alert(Symbol()+" Period "+Period()+" WPR Short Cross ",short_level);
               
               }

//long
      if(maOnArray[i]>maOnArray[i+1] && 
         maOnArray[i]>long_level 
            && maOnArray[i+1]<=long_level 
               && maOnArray[i+valid_bars_back]< long_level-valid_bars_back_diff)
                  
      {
       arrow2[i]=ma[i];
       
       string name = "Up"+i;
       ObjectCreate(name, OBJ_ARROW, 0, Time[i], Low[i]-30*Point); //draw an up arrow
       ObjectSet(name, OBJPROP_STYLE, STYLE_SOLID);
       ObjectSet(name, OBJPROP_ARROWCODE, SYMBOL_ARROWUP);
       ObjectSet(name, OBJPROP_COLOR,Blue);

      }
         else {arrow2[i]=0.00;}
  //--long alert--+
  
      if(maOnArray[0]>maOnArray[1] && 
         maOnArray[0]>long_level 
            && maOnArray[1]<=long_level 
               && maOnArray[0+valid_bars_back]< long_level-valid_bars_back_diff)
               {
      if(alert_on== true && NewBar()==true  )Alert(Symbol()+" Period "+Period()+" WPR Long Cross ",long_level);
                   
               }
}   
   

//---Trigger Visuals
if(show_trigger_lines!=false)
{
   for( i = Bars_Back-1-wperiod; i >= 0; i--)
   {
         
      ObjectDelete("WTnowline");
      ObjectDelete("WThighline");
      ObjectDelete("WTlowline");
      
      
      int windowIndex=WindowFind("Williams_Trade_V1.2.2");  
      ObjectCreate("WTnowline",OBJ_HLINE,windowIndex,0,maOnArray[i]);
      ObjectSet("WTnowline",OBJPROP_COLOR,Orange);
      ObjectSet("WTnowline",OBJPROP_WIDTH,1);
      
      windowIndex=WindowFind("Williams_Trade_V1.2.2");  
      ObjectCreate("WThighline",OBJ_HLINE,windowIndex,0,short_level);
      ObjectSet("WThighline",OBJPROP_COLOR,Crimson);
      ObjectSet("WThighline",OBJPROP_WIDTH,1);
      
      windowIndex=WindowFind("Williams_Trade_V1.2.2");  
      ObjectCreate("WTlowline",OBJ_HLINE,windowIndex,0,long_level);
      ObjectSet("WTlowline",OBJPROP_COLOR,Green);
      ObjectSet("WTlowline",OBJPROP_WIDTH,1);
      WindowRedraw();
      }}
   return(0);
  }
  bool NewBar()
{
   //static datetime lastbar;
   datetime curbar = Time[0];
   if(lastbar!=curbar)
   {
      lastbar=curbar;
      return (true);
   }
   else
   {
      return(false);
   }
}
 